<template>
	<div class="flex w-full lg:w-690 h-full flex-col">
		<MkCheckoutEmail
			v-if="stepsCompleted == 1"
			:value="formatData"
			:steps-completed="stepsCompleted"
			@completedstep="completedstep"
		/>
		<MkCheckoutAccount
			v-else
			:value="formatData"
			:page="page"
			@edit-email="editEmail"
			@sign-out="handleSignOut"
			@giftTriggered="giftTriggered"
		/>
		<MkCheckoutShipping
			v-if="stepsCompleted <= 2"
			:editing="editing"
			:cancel="cancel"
			:step-title="stepTitle"
			:value="shippingInfo"
			:steps-completed="stepsCompleted"
			:last-edit="lastEdit"
			@completedstep="completedstep"
			@cancel-shipping="cancelShipping"
			@add-address="addAddress"
			@update-address="updateAddress"
		/>
		<MkShippingInfo
			v-if="stepsCompleted != 1 && stepsCompleted != 2"
			:step-title="stepTitle"
			:value="shippingInfo"
			:last-edit="lastEdit"
			@edit-shipping="editShipping"
		/>
		<MkCheckoutShippingMethod
			v-if="stepsCompleted <= 3"
			:value="shippingMethod"
			:steps-completed="stepsCompleted"
			:page="page"
			@completedstep="completedstep"
		/>
		<MkCheckoutShippingMethodSuccess
			v-if="stepsCompleted != 1 && stepsCompleted != 2 && stepsCompleted != 3"
			:value="shippingMethod"
			:last-edit="lastEdit"
			:page="page"
			@edit-shipping-method="editShippingmethod"
		/>
		<MkCheckoutPayment
			v-if="stepsCompleted <= 4"
			v-model="paymentInfo"
			:shipping-address="shippingInfo.addressData"
			:value="paymentInfo"
			:steps-completed="stepsCompleted"
			:page="page"
			@completedstep="completedstep"
		/>
		<MkCheckoutPaymentSuccess
			v-if="stepsCompleted != 1 && stepsCompleted != 2 && stepsCompleted != 3 && stepsCompleted != 4"
			:value="paymentInfo"
			:page="page"
			@paymentmethod="paymentmethod"
		/>
	</div>
</template>
<script>
import { mapState } from 'vuex';
import MkCheckoutEmail from '~/components/D2C/molecules/MkCheckoutEmail.vue';
import MkCheckoutShipping from '~/components/D2C/molecules/MkCheckoutShipping.vue';
import MkCheckoutShippingMethod from '~/components/D2C/molecules/MkCheckoutShippingMethod.vue';
import MkCheckoutPayment from '~/components/D2C/molecules/MkCheckoutPayment.vue';
import MkCheckoutPaymentSuccess from '~/components/D2C/molecules/MkCheckoutPaymentSuccess.vue';
import MkCheckoutShippingMethodSuccess from '~/components/D2C/molecules/MkCheckoutShippingMethodSuccess.vue';
import MkCheckoutAccount from '~/components/D2C/molecules/MkCheckoutAccount.vue';
import MkShippingInfo from '~/components/D2C/molecules/MkShippingInfo.vue';
export default {
	name: 'MkCheckoutLayout',
	components: {
		MkCheckoutEmail,
		MkCheckoutShipping,
		MkCheckoutShippingMethod,
		MkCheckoutPayment,
		MkCheckoutPaymentSuccess,
		MkCheckoutShippingMethodSuccess,
		MkCheckoutAccount,
		MkShippingInfo,
	},
	props: {
		page: {
			type: Object,
			default: () => {},
		},
	},
	data() {
		return {
			stepsCompleted: 1,
			formatData: {
				email: '',
				password: '',
				accepted: false,
				gifted: false,
				acceptedUK: false,
				acceptedNewsUK: false,
			},
			lastEdit: 'Info',
			shippingInfo: {
				businessprofile: false,
				addressData: {},
				recipientsEmail: '',
				giftMessage: '',
			},
			shippingMethod: {
				method: '',
			},
			paymentInfo: {
				useBillingAddress: true,
				selectedCard: {},
				addressData: {
					firstName: '',
					lastName: '',
					address1: '',
					address2: '',
					city: '',
					state: '',
					postalCode: '',
					phoneNumber: '',
					country: '',
				},
			},
			stepTitle: 'Shipping',
			editing: false,
			cancel: false,
			previousStepsCompleted: null,
		};
	},
	computed: {
		...mapState('USER_STORE', ['AUTHENTICATED']),
		...mapState('CART_STORE', ['GIFT']),
	},
	watch: {
		paymentInfo: {
			deep: true,
			handler() {
				this.$emit('payment-data', this.paymentInfo);
			},
		},
		AUTHENTICATED() {
			if (this.AUTHENTICATED) {
				this.stepsCompleted = 2;
			}
		},
	},
	mounted() {
		if (this.AUTHENTICATED) {
			this.stepsCompleted = 2;
		}
	},
	methods: {
		completedstep() {
			if (!this.editing) {
				if (this.stepsCompleted !== 5) {
					this.stepsCompleted++;
				}
			} else {
				this.editing = false;
				this.stepsCompleted = this.previousStepsCompleted;
			}
		},
		editEmail() {
			this.editing = true;
			this.previousStepsCompleted = this.stepsCompleted;
			this.stepsCompleted = 1;
			this.lastEdit = 'email';
		},
		editShipping() {
			this.editing = true;
			this.cancel = true;
			this.previousStepsCompleted = this.stepsCompleted;
			this.stepsCompleted = 2;
			this.lastEdit = 'address';
		},
		cancelShipping() {
			this.cancel = false;
			this.stepsCompleted = this.previousStepsCompleted;
		},
		editShippingmethod() {
			this.editing = true;
			this.previousStepsCompleted = this.stepsCompleted;
			this.stepsCompleted = 3;
			this.lastEdit = 'method';
		},
		paymentmethod() {
			this.editing = true;
			this.previousStepsCompleted = this.stepsCompleted;
			this.stepsCompleted = 4;
		},
		addAddress(data) {},
		handleSignOut() {
			this.stepsCompleted = 1;
			this.formatData.password = '';
			this.formatData.email = '';
			this.$store.dispatch('USER_STORE/EXIST_USER_ALERT');
		},
		giftTriggered() {
			this.stepsCompleted = 2;
		},
		updateAddress() {
			this.shippingInfo = {
				businessprofile: false,
				addressData: {},
				recipientsEmail: '',
				giftMessage: '',
			};
		},
	},
};
</script>
